<?php

function fantacalcio_admin_formazione($t_id = "", $league_name = ''){

	if(!is_team($t_id)) return choose_team_formazione_admin();

	else return fantacalcio_insert_formazione_admin($league_name, $t_id);
}

function choose_team_formazione_admin(){
	$out = '';

	$teams = get_teams();

	foreach($teams as $t_id => $team){
		$team_names[] = $team["name"];
	}

	array_multisort($team_names, $teams);

	$out .= "<ul>";
	foreach($teams as $t_id => $team){
		$out .= "<li>".l($teams[$t_id]['name'], "formazione/admin/".$teams[$t_id]['t_id'])."</li>";
	}
	$out .= "</ul>";

	return $out;
}

function fantacalcio_insert_formazione_admin($league_name = '', $t_id) {

	global $user;

	$leagues = get_leagues();

	if (empty ($league_name) || !is_league($league_name)) {

		#controllo quante formazioni vanno inserite per la giornata
		$vote_round = get_last_votes() or 0;
		$vote_round++;
		$sql = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d'";
		$result = db_query($sql, $vote_round);
		while($row = db_fetch_array($result)){
			$sqla = "SELECT * FROM {league_matches} " .
					"WHERE l_id = '%d' " .
					"AND round = '%d' " .
					"AND (t1_id = '%d' OR t2_id = '%d')";
			$resulta = db_query($sqla, $row['l_id'], $row['league_round'], $t_id, $t_id);
			while($rowa = db_fetch_array($resulta)){
				$formazioni[$rowa['l_id']] = $rowa['round'];
			}
		}

		if(count($formazioni) > 1){
			$teams = get_teams();
			$out = "<h3>".$teams[$t_id]['name']."</h3>";

			$out .= "<p>Inserire una formazione per ogni partita</p>";

			$out .= "<ul>";
			foreach($formazioni as $l_id => $round){
				$league = $leagues[$l_id];
				$out .= "\n<li><a href='".base_path()."formazione/admin/".$t_id."/".$league->name."'>".$league->name." (".$round."&ordf; Giornata)</a></li>";
			}
			$out .= "</ul>";
			return $out;
		}
		elseif(count($formazioni) == 1) {
			foreach($formazioni as $l_id => $round) $league_name = $leagues[$l_id]->name;

			return insert_formazione_admin($league_name, $t_id);
		}
	}

	else return insert_formazione_admin($league_name, $t_id);

}

function insert_formazione_admin($league_name, $t_id){

	drupal_add_js('misc/ajax.js');
	drupal_add_css('sites/all/modules/fantacalcio/style.css', 'themes', 'all', FALSE);

	$l_id = get_league_id($league_name);
	$round = get_next_round_formazione($l_id);
	$teams = get_teams();

	$out = '';

	$ts_match = get_timestamp_match($l_id, $round);

	$js = "function a(){
				var sub = document.getElementById('submit');
				sub.disabled = false;
		}";
	drupal_add_js($js, 'inline');

	$out .= "\n<h3>" . ucwords($league_name) . "</h3>";
	$out .= "\n<h4>" . $round . "&#7491; giornata</h4>";
	$out .= "\n<h3>" . $teams[$t_id]['name'] . "</h3>";

	$args = array (
		't_id' => $t_id,
		'l_id' => $l_id,
		'round' => $round,
	);

	$formazione_form = drupal_get_form('fantacalcio_formazione_form', $args);

	$args_confirm = get_args_confirm($args);

	$out .= confirm_formazione($args_confirm);

	$validate = fantacalcio_formazione_validate($l_id, $round, $t_id);

	$out .= "\n<div id='validate'>" . $validate['output'] . "</div>";



	$out .= "\n<div id='formazione_form'>" . $formazione_form . "</div>";

	$out .= "\n<div class='clear' style='height:10px;'></div>";

	$out .= "\n<div id='formazione'>" .
			make_formazione($t_id, $l_id, $round) .
			"\n</div>";

	return $out;

}

function fantacalcio_calcola_modificatori() {

	$out = "";

	$vote_round = get_last_votes();
	$teams = get_teams();
	$votes = get_votes($vote_round);
	$leagues = get_leagues();

	$matches = get_matches_vote_round($vote_round);

	foreach ($matches as $m_id => $match) {

		$t1_id = $match->t1_id;
		$t2_id = $match->t2_id;
		$league_round = $match->round;
		$l_id = $match->l_id;

		$mod_difesa_1 = fantacalcio_calcola_modificatori_difesa($t1_id, $l_id, $vote_round, $league_round);
		$mod_difesa_2 = fantacalcio_calcola_modificatori_difesa($t2_id, $l_id, $vote_round, $league_round);
		$mod_centrocampo = fantacalcio_calcola_modificatori_centrocampo($t1_id, $t2_id, $l_id, $vote_round, $league_round);
		$mod_centrocampo_1 = $mod_centrocampo[1];
		$mod_centrocampo_2 = $mod_centrocampo[2];

		$sql = "UPDATE {league_matches} SET " .
		"mod_dif_1 = '$mod_difesa_1', " .
		"mod_dif_2 = '$mod_difesa_2', " .
		"mod_centr_1 = '$mod_centrocampo_1', " .
		"mod_centr_2 = '$mod_centrocampo_2' " .
		"WHERE m_id = ".$match->m_id;
		$result = db_query($sql);#, $mod_difesa_1, $mod_difesa_2, $mod_centrocampo_1, $mod_centrocampo_2, $match->m_id);
	}

	$sqlx = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d'";
	$resultx = db_query($sqlx, $vote_round);
	while($rowx = db_fetch_array($resultx)){
		$l_id = $rowx['l_id'];
		$league_round = $rowx['league_round'];

		$sql = "SELECT * FROM {league_matches} " .
				"WHERE l_id = '%d' " .
				"AND round = '%d' ";
		$result = db_query($sql, $l_id, $league_round);
		$out .= "<h3>".$leagues[$l_id]->name."</h3>";

		$header = array("Team 1", "Dif 1", "Centr 1", "Team 2", "Dif 2", "Centr 2");
		$rows = array();

		while ($row = db_fetch_array($result)) {

			$rows[$row['m_id']][] = $teams[$row['t1_id']]['name'];
			$rows[$row['m_id']][] = $row['mod_dif_1'];
			$rows[$row['m_id']][] = $row['mod_centr_1'];
			$rows[$row['m_id']][] = $teams[$row['t2_id']]['name'];
			$rows[$row['m_id']][] = $row['mod_dif_2'];
			$rows[$row['m_id']][] = $row['mod_centr_2'];

		}

		$out .= theme_table($header, $rows);

	}

	return $out;

}

function fantacalcio_calcola_modificatori_centrocampo($t1_id, $t2_id, $l_id, $vote_round, $league_round) {

	$centr_t1_ids = array ();
	$n_centr_t1_titolari = 0;
	$n_centr_t1_entrati = 0;
	$centr_t2_ids = array ();
	$n_centr_t2_titolari = 0;
	$n_centr_t2_entrati = 0;

	#team 1
	$sql = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
	"WHERE f.pl_id = p.pl_id " .
	"AND p.role = 2 " .
	"AND f.l_id = '%d' " .
	"AND f.round = '%d'" .
	"AND f.t_id = '%d'";
	$result = db_query($sql, $l_id, $league_round, $t1_id);
	while ($row = db_fetch_array($result)) {
		if ($row['gioca'] == 1) {
			array_push($centr_t1_ids, $row['pl_id']);
			$n_centr_t1_entrati++;
		}

		if ($row['posizione'] == 1)
			$n_centr_t1_titolari++;

	}

	#team 2
	$sql = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
	"WHERE f.pl_id = p.pl_id " .
	"AND p.role = 2 " .
	"AND f.l_id = '%d' " .
	"AND f.round = '%d'" .
	"AND f.t_id = '%d'";
	$result = db_query($sql, $l_id, $league_round, $t2_id);
	while ($row = db_fetch_array($result)) {
		if ($row['gioca'] == 1) {
			array_push($centr_t2_ids, $row['pl_id']);
			$n_centr_t2_entrati++;
		}

		if ($row['posizione'] == 1)
			$n_centr_t2_titolari++;

	}

	$elenco_centr_t1_ids = implode(',', $centr_t1_ids);
	$elenco_centr_t2_ids = implode(',', $centr_t2_ids);

	$tot_centr_t1 = 0;
	$tot_centr_t2 = 0;

	#voti team 1
	$sql = "SELECT * FROM {fanta_votes} " .
	"WHERE pl_id IN ($elenco_centr_t1_ids) " .
	"AND round = '%d'";
	$result = db_query($sql, $vote_round);
	while ($row = db_fetch_array($result)) {
		$tot_centr_t1 += $row['vote'];
	}

	#voti team 2
	$sql = "SELECT * FROM {fanta_votes} " .
	"WHERE pl_id IN ($elenco_centr_t2_ids) " .
	"AND round = '%d'";
	$result = db_query($sql, $vote_round);
	while ($row = db_fetch_array($result)) {
		$tot_centr_t2 += $row['vote'];
	}

	$tot_centr_t1 += 5 * ($n_centr_t1_titolari - $n_centr_t1_entrati);
	$tot_centr_t2 += 5 * ($n_centr_t2_titolari - $n_centr_t2_entrati);

	if ($n_centr_t1_titolari > $n_centr_t2_titolari)
		$tot_centr_t2 += 5 * ($n_centr_t1_titolari - $n_centr_t2_titolari);

	if ($n_centr_t2_titolari > $n_centr_t1_titolari)
		$tot_centr_t1 += 5 * ($n_centr_t2_titolari - $n_centr_t1_titolari);

	$scarto = $tot_centr_t1 - $tot_centr_t2;

	$scarto = floor(abs($scarto)) / 2;

	if ($tot_centr_t1 > $tot_centr_t2)
		$mod_centrocampo = array (
			1 => $scarto,
			2 => 0 - $scarto
		);

	if ($tot_centr_t1 < $tot_centr_t2)
		$mod_centrocampo = array (
			1 => 0 - $scarto,
			2 => $scarto
		);

	if ($tot_centr_t1 == $tot_centr_t2)
		$mod_centrocampo = array (
			1 => 0,
			2 => 0
		);

	return $mod_centrocampo;

}

function fantacalcio_calcola_modificatori_difesa($t_id, $l_id, $vote_round, $league_round) {

	$dif_ids = array ();
	$n_dif_titolari = 0;
	$n_dif_entrati = 0;
	$sql = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
	"WHERE f.pl_id = p.pl_id " .
	"AND p.role = 1 " .
	"AND f.l_id = '%d' " .
	"AND f.round = '%d'" .
	"AND f.t_id = '%d'";
	$result = db_query($sql, $l_id, $league_round, $t_id);
	while ($row = db_fetch_array($result)) {

		if ($row['gioca'] == 1) {
			array_push($dif_ids, $row['pl_id']);
			$n_dif_entrati++;
		}

		if ($row['posizione'] == 1)
			$n_dif_titolari++;

	}

	$elenco_dif_ids = implode(',', $dif_ids);

	$tot_difesa = 0;
	$sql = "SELECT * FROM {fanta_votes} " .
	"WHERE pl_id IN ($elenco_dif_ids) " .
	"AND round = '%d'";
	$result = db_query($sql, $vote_round);
	while ($row = db_fetch_array($result)) {
		$tot_difesa += $row['vote'];
	}

	$tot_difesa += 5 * ($n_dif_titolari - $n_dif_entrati);
	$avg_difesa = round($tot_difesa / $n_dif_titolari, 2);

	$mod_difesa = 27 - $n_dif_titolari - floor($avg_difesa * 4);

	#echo "$t_id : $tot_difesa : $avg_difesa : $n_dif_titolari : $mod_difesa <br>";

	return $mod_difesa;
}

function fantacalcio_trova_titolari() {

	$out = "";

	$vote_round = get_last_votes();

	$teams = get_teams();
	$votes = get_votes($vote_round);
	$leagues = get_leagues();

	$pl_votes = array ();
	foreach ($votes as $vote)
		$pl_votes[] = $vote->pl_id;

	$elenco_pl_ids = implode(',', $pl_votes);

	$sqlx = "SELECT * FROM {fanta_votes_round} " .
			"WHERE vote_round = '%d'";
	$resultx = db_query($sqlx, $vote_round);

	#echo db_affected_rows($result);

	while($row = db_fetch_array($resultx)){

		$l_id = $row['l_id'];
		$league_round = $row['league_round'];

		#$league_round = get_last_league_round($l_id);

		$out .= "<h3>" . $leagues[$l_id]->name . "</h3>";

		#titolari con voto
		$sql = "UPDATE {fanta_formazioni} " .
		"SET gioca = 1 " .
		"WHERE posizione = 1 " .
		"AND round = '%d' " .
		"AND l_id = '%d'" .
		"AND pl_id IN ($elenco_pl_ids)";
		$result = db_query($sql, $league_round, $l_id);
		#$out .= db_affected_rows($result)." t- ";

		#titolari senza voto da sostituire
		$sql = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
		"WHERE p.pl_id = f.pl_id " .
		"AND f.gioca = 0 " .
		"AND f.posizione = 1 " .
		"AND f.round = '%d' " .
		"AND f.l_id = '%d'";
		$result = db_query($sql, $league_round, $l_id);
		#$out .= db_affected_rows($result)." Nt- ";

		while ($row = db_fetch_array($result)) {

			$role = $row['role'];
			$t_id = $row['t_id'];

			#1a riserva dello stesso ruolo
			$sqla = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
			"WHERE p.pl_id = f.pl_id " .
			"AND f.posizione = 2 " .
			"AND f.gioca = 0 " .
			"AND p.role = '%d' " .
			"AND f.round = '%d' " .
			"AND f.l_id = '%d' " .
			"AND f.t_id = '%d' ";
			$resulta = db_query($sqla, $role, $league_round, $l_id, $t_id);

			if(db_affected_rows($resulta) > 0){

				while ($rowa = db_fetch_array($resulta)) {
					$pl_id = $rowa['pl_id'];

					#se con il voto entra la prima riserva
					if (in_array($pl_id, $pl_votes)) {
						$sqlb = "UPDATE {fanta_formazioni} set gioca = 1 " .
						"WHERE pl_id = '%d' " .
						"AND t_id = '%d' " .
						"AND l_id = '%d' " .
						"AND round = '%d'";
						$resultb = db_query($sqlb, $pl_id, $t_id, $l_id, $league_round);
					}
					#se senza voto cerco la seconda riserva
					else {
						$sqlb = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
						"WHERE p.pl_id = f.pl_id " .
						"AND f.posizione = 3 " .
						"AND f.gioca = 0 " .
						"AND p.role = '%d' " .
						"AND f.round = '%d' " .
						"AND f.l_id = '%d' " .
						"AND f.t_id = '%d' ";
						$resultb = db_query($sqlb, $role, $league_round, $l_id, $t_id);
						while ($rowb = db_fetch_array($resultb)) {
							$pl_id = $rowb['pl_id'];
							if (in_array($pl_id, $pl_votes)) {
								$sqlc = "UPDATE {fanta_formazioni} set gioca = 1 " .
								"WHERE pl_id = '%d' " .
								"AND t_id = '%d' " .
								"AND l_id = '%d' " .
								"AND round = '%d'";
								$resultc = db_query($sqlc, $pl_id, $t_id, $l_id, $league_round);
							}
						}
					}
				}
			}

			#nessuna prima riserva ancora non entrata
			else {
				$sqlb = "SELECT * FROM {fanta_formazioni} f, {fanta_players} p " .
				"WHERE p.pl_id = f.pl_id " .
				"AND f.posizione = 3 " .
				"AND f.gioca = 0 " .
				"AND p.role = '%d' " .
				"AND f.round = '%d' " .
				"AND f.l_id = '%d' " .
				"AND f.t_id = '%d' ";
				$resultb = db_query($sqlb, $role, $league_round, $l_id, $t_id);
				while ($rowb = db_fetch_array($resultb)) {
					$pl_id = $rowb['pl_id'];
					if (in_array($pl_id, $pl_votes)) {
						$sqlc = "UPDATE {fanta_formazioni} set gioca = 1 " .
						"WHERE pl_id = '%d' " .
						"AND t_id = '%d' " .
						"AND l_id = '%d' " .
						"AND round = '%d'";
						$resultc = db_query($sqlc, $pl_id, $t_id, $l_id, $league_round);
					}
				}
			}

		}

		#report
		$sql = "SELECT count(*) AS n, t_id FROM {fanta_formazioni} " .
				"WHERE gioca = 1 " .
				"AND l_id = '%d' " .
				"AND round = '%d'" .
				"GROUP BY t_id";
		$result = db_query($sql, $l_id, $league_round);
		$played = array ();
		$i = 0;
		while ($row = db_fetch_array($result)) {
			$i++;
			$played[$i]['t_id'] = $row['t_id'];
			$played[$i]['n'] = $row['n'];
		}


		$players = get_players();

		$sql = "SELECT * FROM {fanta_formazioni} " .
				"WHERE l_id = '%d' " .
				"AND round = '%d'";
		$result = db_query($sql, $l_id, $league_round);
		$formazioni = array();
		while ($row = db_fetch_object($result)) {

			$role = $players[$row->pl_id]->role;

			if($row->posizione == 1)	$formazioni[$row->t_id]["titolari"][$role]++;
			if($row->gioca == 1) $formazioni[$row->t_id]["played"][$role]++;
		}

		#riepilogo titolari squadre
		$header = array("Squadra", "N° Titolari", "Mod Titolari", "Mod Formazione");

		#print_r($formazioni);

		$rows = array();
		foreach ($formazioni as $key => $value) {
			$n_titolari = array_sum($formazioni[$key]["played"]);

			$style = ($n_titolari == 11) ? "" : "font-weight: bold; color: red;";

			ksort($formazioni[$key]["played"]);
			ksort($formazioni[$key]["titolari"]);

			$rows[$key][] = $teams[$key]['name'];
			$rows[$key][] = array("data" => $n_titolari, "style" => $style);
			$rows[$key][] = implode("-", $formazioni[$key]["played"]);
			$rows[$key][] = implode("-", $formazioni[$key]["titolari"]);
		}
		$out .= theme_table($header, $rows);

	}

	return $out;

}

function fantacalcio_risultati_calcolati() {

	$leagues = get_leagues();
	$calcolati = 0;

	foreach ($leagues as $l_id => $league) {

		$last_round = get_last_formazioni($l_id);

		$n_played = get_league_played($l_id);

		if ($n_played == $last_round)
			$calcolati++;
	}

	if ($calcolati == 0)
		return FALSE;
	else
		return TRUE;

}

function fantacalcio_calcola_totali() {

	$vote_round = get_last_votes();
	$teams = get_teams();
	$votes = get_votes($vote_round);
	$leagues = get_leagues();

	$matches = array ();
	foreach ($leagues as $l_id => $league) {
		$league_round = get_last_league_round($l_id);
		$matches_leagues = get_round_matches($league_round, '', $l_id);

		$matches = array_merge($matches, $matches_leagues);
	}

	$out = '';

	$header = array("Lega", "Team1", "Voti", "Mod Dif", "Mod Centr", "+", "Tot", "Gol", "Team1", "Voti", "Mod Dif", "Mod Centr", "+", "Tot", "Gol");

	foreach ($matches as $m_id => $match) {

		$t1_id = $match->t1_id;
		$t2_id = $match->t2_id;
		$league_round = $match->round;
		$l_id = $match->l_id;

		$mod_dif_1 = $match->mod_dif_1;
		$mod_dif_2 = $match->mod_dif_2;
		$mod_centr_1 = $match->mod_centr_1;
		$mod_centr_2 = $match->mod_centr_2;
		$bonus_t1 = $match->bonus_t1;
		$bonus_t2 = $match->bonus_t2;

		$tot_voti_1 = get_totale($t1_id, $league_round, $vote_round, $l_id);
		$tot_voti_2 = get_totale($t2_id, $league_round, $vote_round, $l_id);

		$tot_1 = $tot_voti_1 + $mod_dif_2 + $mod_centr_1 + $bonus_t1;
		$tot_2 = $tot_voti_2 + $mod_dif_1 + $mod_centr_2 + $bonus_t2;

		$gol_1 = floor(($tot_1 -60) / 6);
		$gol_2 = floor(($tot_2 -60) / 6);
		$gol_1 = ($gol_1 >= 0) ? $gol_1 : 0;
		$gol_2 = ($gol_2 >= 0) ? $gol_2 : 0;

		$winner_id = ($gol_1 > $gol_2) ? $t1_id : $t2_id;
		$winner_id = ($gol_1 == $gol_2) ? -1 : $winner_id;

		$rows[$m_id][] = $l_id;
		$rows[$m_id][] = substr( $teams[$t1_id]['name'], 0 , 5);
		$rows[$m_id][] = $tot_voti_1;
		$rows[$m_id][] = $mod_dif_2;
		$rows[$m_id][] = $mod_centr_1;
		$rows[$m_id][] = $bonus_t1;
		$rows[$m_id][] = $tot_1;
		$rows[$m_id][] = $gol_1;
		$rows[$m_id][] = substr( $teams[$t2_id]['name'], 0 , 5);
		$rows[$m_id][] = $tot_voti_2;
		$rows[$m_id][] = $mod_dif_1;
		$rows[$m_id][] = $mod_centr_2;
		$rows[$m_id][] = $bonus_t2;
		$rows[$m_id][] = $tot_2;
		$rows[$m_id][] = $gol_2;
		$rows[$m_id][] = $winner_id;

		$sql = "UPDATE {league_matches} SET " .
		"pt_1 = $tot_voti_1, " .
		"pt_2 = $tot_voti_2, " .
		"tot_1 = $tot_1, " .
		"tot_2 = $tot_2, " .
		"gol_1 = $gol_1, " .
		"gol_2 = $gol_2, " .
		"played = 1, " .
		"winner_id = $winner_id " .
		"WHERE m_id = ".$match->m_id;
		$result = db_query($sql);

	}
	$out .= theme_table($header, $rows);# "</table>";

	return $out;
}

function fantacalcio_calcola_scommesse() {

	$vote_round = get_last_votes();
	$teams = get_teams();
	$users = get_users();
	$round = get_last_league_round(1);
	$bets_users = get_bets_users($round);
	$matches = get_bets_matches($round);
	$bets = get_round_bets($round);

	$sql = "DELETE FROM {bets_points} WHERE round = '%d'";
	$result = db_query($sql, $round);

	$sql = "DELETE FROM {bets_jackpot} WHERE round = '%d'";
	$result = db_query($sql, $round);

	foreach($matches as $m_id => $match){

		$count_bets = array('1' => 0, '2' => 0, 'X' => 0);

		$match_bets = $bets[$match->m_id];

		$num_bets = 0;

		if($match_bets){

			foreach($match_bets as $u_id => $bet_group){

				$i = 0;
				foreach($bet_group as $bet_id => $bet){

					$i++;
					if(!empty($bet)){
						$value = change_bet_value($bet, $match->t1_id, $match->t2_id);

						$count_bets[$value]++;
						$num_bets++;

						$class = ($i == 1) ? "first_bet " : '';
						if($bet == $match->winner_id){
							$class .= 'won';
							$wons[$u_id][$bet_id][] = $match->m_id;
						}
						else $wons[$u_id][$bet_id][] = "";

					}
				}
			}
		}
		$winner = get_winner($match);

		$match_winners[$match->m_id] = $winner;

	}

	$max_won = 0; $user_winners = array();

	$schedine_giocate = 0;
	foreach($wons as $u_id => $bet_group){

		ksort($bet_group);

		foreach($bet_group as $bet_id => $won){

			$num = 0;
			foreach($match_winners as $m_id => $match_winner){
				if(in_array($m_id, $won)) $num++;
			}

			if($max_won <= $num && $num > 0) {
				if($max_won < $num) $user_winners = array();
				$user_winners[$u_id]++;
				$max_won = $num;
			}

			$schedine_giocate++;
		}
	}

	#riepilogo
	$importo_totale = $schedine_giocate * BET_PRICE;

	if($max_won == count($matches)){
		$jackpot = get_jackpot($round);
		$quota_vittoria = ($importo_totale + $jackpot ) / array_sum($user_winners);
		$quota_jackpot = 0;
	}
	elseif($max_won == 0){
		$quota_vittoria = 0;
		$quota_jackpot = $importo_totale;
	}
	else {
		$quota_vittoria = ($importo_totale * (1 - JACKPOT_PERCENT ) ) / array_sum($user_winners);
		$quota_jackpot = ($importo_totale * (JACKPOT_PERCENT));
	}

	$header_riepilogo[] = array("data" => "Riepilogo", "colspan" => 2);

	$winner_title = (count($user_winners) > 1) ? "Vincitori" : "Vincitore";

	if($user_winners){
		foreach($user_winners as $u_id => $user_winner){
			$num_won = ($user_winner == 1) ? "" : " ($user_winner)";
			$winners .=  $users[$u_id]->name.$num_won.", ";

			$sql = "INSERT INTO {bets_points} (u_id, round, num, points) VALUES " .
			"(" . $u_id . ", $round, " . $max_won . ", " . $quota_vittoria. ")";
			$result = db_query($sql);
		}
		$winners = substr($winners, 0, -2);
	}
	else $winners = " - ";

	$rows_riepilogo[] = array($winner_title, $winners);
	$rows_riepilogo[] = array("Scommesse giuste", $max_won);
	$rows_riepilogo[] = array("Schedine giocate", $schedine_giocate );
	$rows_riepilogo[] = array("Importo totale", sprintf("%01.2f", $importo_totale) . " &euro;" );
	$rows_riepilogo[] = array("Quota Vittoria", sprintf("%01.2f", $quota_vittoria) . " &euro;");
	$rows_riepilogo[] = array("Quota Jackpot", sprintf("%01.2f", $quota_jackpot). " &euro;");

	$sql = "INSERT INTO {bets_jackpot} (round, quote) VALUES " .
		"(" .$round. ", " . $quota_jackpot. ")";
	$result = db_query($sql);

	return theme_table($header_riepilogo, $rows_riepilogo);
}

function fantacalcio_controlla_formazioni(){
	$vote_round = get_last_votes() + 1;
	$teams = get_teams();
	$leagues = get_leagues();

	$formazioni = array();
	foreach($leagues as $l_id => $league){
		$result = db_query("SELECT league_round FROM {fanta_votes_round} WHERE l_id = '%d' AND vote_round = '%d'", $l_id, $vote_round);
		$last_round = db_result($result);

		$sql = "SELECT * FROM {league_matches} " .
				"WHERE l_id = '%d' " .
				"AND round = '%d'";
		$result = db_query($sql, $l_id, $last_round);
		while($row = db_fetch_object($result)){
			$league_teams[$l_id][] = $row->t1_id;
			$league_teams[$l_id][] = $row->t2_id;
		}

		$sql = "SELECT * FROM {fanta_formazioni} " .
				"WHERE l_id = '%d' " .
				"AND round = '%d'";
		$result = db_query($sql, $l_id, $last_round);
		while($row = db_fetch_object($result)){
			$formazioni[$l_id][$row->t_id][] = $row;
		}
	}

	foreach($formazioni as $l_id => $formazioni_league){

		$rows = array();

		$out  .= "<h3>".$leagues[$l_id]->name."</h3>";

		foreach($league_teams[$l_id] as $t_id){

			$formazione = $formazioni_league[$t_id];

			$modulo = array();

			if($formazione){

				foreach($formazione as $player){
					if($player->posizione > 0) $modulo[$player->posizione]++;
				}

				if($modulo == array(1=>11,2=>4,3=>3))	$status = "<span style='color: green; font-weight:bold;'>OK</span>";
				else $status = "<span style='color: red; font-weight:bold;'>NO</span>";
				ksort($modulo);

				$rows[$t_id] = array(l($teams[$t_id]['name'], "formazione/admin/".$t_id), implode(" - ",$modulo), $status);
			}
			else $rows[$t_id] = array(l($teams[$t_id]['name'], "formazione/admin/".$t_id), array("data" => "<span style='color: red; font-weight:bold;'>NON INSERITA</span>", "colspan" => 2));

		}

		$out .= theme_table(array(), $rows);

	}

	return $out;
}

function fantacalcio_upload_voti() {
	return drupal_get_form('voti_upload_form');
}

function voti_upload_form_clear($form, & $form_state) {
	$form_state['rebuild'] = TRUE;
}

function voti_upload_form_submit($form, & $form_state) {

	$path = 'sites/default/files/voti';

	if ($file = file_save_upload('voti', array (), $path)) {
		$sql = "select max(round) from {fanta_votes};";
		$result = db_query($sql);
		$round = db_result($result) + 1;

		ins_voti_tutti6($form_state["values"]["teams"], $round);
		$out = ins_voti($file, $path, $round);
		drupal_set_message('File caricato');
		drupal_set_message($out);
	}
	else drupal_set_message('Errore nel caricamento');

}

function ins_voti($file, $path, $round) {

	$sql = "select max(round) from {fanta_votes};";
	$result = db_query($sql);
	$giornata = db_result($result) + 1;

	$file_righe = file($path . '/' . $file->filename);
	$query_values = array();

	$count_1 = count($file_righe);

	foreach ($file_righe as $key => $riga) {
		$riga = trim($riga);
		if (is_numeric(substr($riga, 0, 1))) {
			$elems = explode(chr(9), $riga);
			foreach ($elems as $id_elem => $elem) {
				$elem = trim($elem);
				#echo "id: $id_elem | val: $elem <br>";
			}
			//controllo se ha preso SV
			if(!is_numeric($elems[3])) $elems[3] = strtr($elems[3], ',', '.');

			if (!is_numeric($elems[3])) {
				if ($elems[1] == 'P') {
					$elems[3] = 6;
					#echo "P senza voto<BR><BR>";
				}
				elseif (($elems[4] + $elems[5] + $elems[6] + $elems[7] + $elems[8] + $elems[9] + $elems[10] + $elems[11] + $elems[12]) != 0) {
					$elems[3] = 6;
					#echo "6<BR><BR>";
				} else {
					#echo "UNSET <br><br>";
					unset ($file_righe[$key]);
				}
				#echo "SV<br><br>";
			}

			if (isset ($file_righe[$key]))
				unset ($elems[1]);

			unset ($elems[2]);
			unset ($elems[13]);
			unset ($elems[14]);

			if (isset ($file_righe[$key]))
				$query_values[$key] = implode(',', $elems);
		}
		else unset ($file_righe[$key]);
	}

	sort($query_values);
	array_unique($query_values);

	$tot = count($file_righe);

	//VOTI della GIORNATA
	$sql = "insert into {fanta_votes} (round, pl_id, vote, gol_fatto, gol_subito, rig_parato, rig_sbagliato, rig_fatto, autogol, amm, esp, assist) values ";
	foreach ($query_values as $riga) {
		$sql .= "\n($round, " . $riga . "),";
	}
	$sql = substr($sql, 0, -1) . ";";
	$result = db_query($sql);

	$formula = " (vote + gol_fatto*3 + rig_fatto*3 + assist + rig_parato*3 - gol_subito - esp - amm*0.5 - autogol*2 - rig_sbagliato*3) ";
	$sql = "update {fanta_votes} set tot = $formula where round = $round";
	db_query($sql);

	$sql = "delete from {fanta_votes}
			where round = $round
			AND (gol_fatto = 0
				AND gol_subito = 0
				AND rig_fatto = 0
				AND assist = 0
				AND rig_parato = 0
				AND gol_subito = 0
				AND esp = 0
				AND amm = 0
				AND autogol = 0
				AND rig_sbagliato = 0)
			AND vote = 'SV'";
	db_query($sql);

	return $tot . " Voti Inseriti";

}

function ins_voti_tutti6($teams = array(), $round){

	if($teams){
		$checked_teams = array();
		foreach($teams as $t_id => $value){
			if($value != "0")	array_push($checked_teams, $value);

		}

		if($checked_teams) {
			$sqla = "INSERT INTO drupal_fanta_votes (pl_id, round, tot, vote) VALUES ";

			$message = "Tutti 6 per i giocatori di";

			$team_sql = "";
			foreach($checked_teams as $team){
				$team_sql .= "'".$team."',";
				$message .= " ".$team.",";
			}
			$team_sql = substr($team_sql, 0, -1);
			$message = substr($message, 0 ,-1);
			drupal_set_message($message);

			$sql = "SELECT pl_id FROM drupal_fanta_players WHERE team in ($team_sql)";
			$result = db_query($sql) ;
			while($row = mysql_fetch_array($result)){
				$sqla .= "\n(".$row["pl_id"].", $round, 6, 6),";
			}
			$sqla = substr($sqla, 0, -1);

			$resulta = db_query($sqla);
		}
	}
}

function voti_upload_form($form_state) {

	// Upload File:
	$form['#attributes'] = array (
		'enctype' => "multipart/form-data"
	);

	$form["tutti6"] = array(
		"#type" => "fieldset",
		"#collapsed" => true,
		"#collapsible" => true,
		"#title" => "Opzioni avanzate",
	);

	$teams_serieA = get_teams_serieA();

	$form["tutti6"]["teams"] = array(
		"#type" => "checkboxes",
		"#title" => "Squadre",
		"#default_value" => array(),
		"#description" => "Squadre che non hanno giocato nella giornata",
		"#options" => $teams_serieA,
	);

	$form['voti'] = array (
		'#type' => 'file',
		'#title' => t('File'
	),);

	$form['submit'] = array (
		'#type' => 'submit',
		'#value' => t('Carica'
	));

	$form['clear'] = array (
		'#type' => 'submit',
		'#value' => 'Annulla',
		'#validate' => array (
			'upload_form_clear'
		),

	);
	return $form;
}

function get_totale($t_id, $league_round, $vote_round, $l_id) {

	$totale = 0;
	$sql = "SELECT * FROM {fanta_votes} v, {fanta_formazioni} f " .
	"WHERE f.pl_id = v.pl_id " .
	"AND f.round = '%d' " .
	"AND v.round = '%d' " .
	"AND f.t_id = '%d' " .
	"AND f.l_id = '%d' " .
	"AND f.gioca = 1";
	$result = db_query($sql, $league_round, $vote_round, $t_id, $l_id);
	while ($row = db_fetch_array($result)) {
		$totale += $row['tot'];
	}

	return $totale;
}

function fantacalcio_risultati($action = '') {

	$out = '';

	drupal_add_css('sites/all/modules/fantacalcio/style.css', 'themes', 'all', FALSE);

	if (fantacalcio_risultati_calcolati())
		return "Risultati già calcolati";

	$actions = array (
		'formazioni' => array (
			'name' => 'Controlla Formazioni',
			'function' => 'controlla_formazioni',
			'order' => 1
		),
		'voti' => array (
			'name' => 'Carica Voti',
			'function' => 'upload_voti',
			'order' => 2
		),
		'titolari' => array (
			'name' => 'Trova titolari',
			'function' => 'trova_titolari',
			'order' => 3
		),
		'modificatori' => array (
			'name' => 'Modificatori',
			'function' => 'calcola_modificatori',
			'order' => 4
		),
		'totali' => array (
			'name' => 'Calcola totali',
			'function' => 'calcola_totali',
			'order' => 5
		),

	);

	if(check_passaggio_turno()){
		$actions['passaggio'] = array (
			'name' => 'Passaggio Turno',
			'function' => 'passaggio_turno',
			'order' => 6
		);

	}

	if (module_exists('bets'))
		$actions['scommesse'] = array (
			'name' => 'Risultati scommesse',
			'function' => 'calcola_scommesse',
			'order' => 8
		);

	$out = "\n<div id='actions'>";
	$out .= get_actions_list($actions, $action);
	$out .= "\n</div>";

	if (!empty ($action) && array_key_exists($action, $actions)) {
		$function = "fantacalcio_" . $actions[$action]['function'];

		$out .= "\n<div id='data'>";
		$out .= $function ();
		$out .= "\n</div>";

	}

	return $out;

}

function get_actions_list($actions, $action = '') {

	foreach($actions as $act){
		$order[] = $act["order"];
	}

	array_multisort($order, $actions);

	$this_order = $actions[$action]['order'];

	$out .= "\n<ul>";
	foreach ($actions as $key => $act) {
		if ($key == $action) {
			$out .= "\n<li class='selected'>" . $act['name'] . "</li>";
		}
		elseif ($act['order'] == ($this_order + 1)) $out .= "\n<li><a href='" . base_path() . arg(0) . "/" . $key . "'>" . $act['name'] . "</a></li>";
		elseif ($act['order'] < ($this_order)) $out .= "\n<li class='done'>" . $act['name'] . "</li>";
		else
			$out .= "\n<li>" . $act['name'] . "</li>";
	}

	$out .= "\n</ul>";

	return $out;
}

function get_teams_serieA(){

	$sql = "SELECT DISTINCT team FROM {fanta_players} ORDER BY team";
	$result = db_query($sql);
	while($row = db_fetch_array($result)){
		$teams[$row["team"]] = $row["team"];
	}
	return $teams;
}

function check_passaggio_turno(){

	$vote_round = get_last_votes();

	$matches = get_matches_vote_round($vote_round);

	foreach($matches as $m_id => $match){
		if($match->next == 1) return true;
		else continue;
	}

	return false;
}

function fantacalcio_passaggio_turno(){

	$out = "";

	$vote_round = get_last_votes();
	$teams = get_teams();

	$matches = get_matches_next($vote_round);

	$header = array("Label", "Team 1", "Team 2", "Goal 1", "Goal 2", "Vincente");

	$rows = array();
	foreach($matches as $label => $matches_label){
		$rows[$label][] = $label;
		foreach($matches_label as $m_id => $match){
			$gol[$match->t1_id]["h"] += $match->gol_1;
			$gol[$match->t2_id]["a"] += $match->gol_2;

			$t1 = $match->t1_id;
			$t2 = $match->t2_id;
		}

		$rows[$label][] = $teams[$match->t1_id]["name"];
		$rows[$label][] = $teams[$match->t2_id]["name"];

		$rows[$label][] = "<b>".array_sum($gol[$t1])."</b> (".$gol[$t1]["h"]." + ".$gol[$t1]["a"].")";
		$rows[$label][] = "<b>".array_sum($gol[$t2])."</b> (".$gol[$t2]["h"]." + ".$gol[$t2]["a"].")";

		//winner
		if(array_sum($gol[$t1]) > array_sum($gol[$t2]) ) $next[$label] = $t1;

		elseif(array_sum($gol[$t1]) < array_sum($gol[$t2]) ) $next[$label] = $t2;

		elseif(array_sum($gol[$t1]) == array_sum($gol[$t2]) ){
			if($gol[$t1]["a"] > $gol[$t2]["a"]) $next[$label] = $t1;

			elseif($gol[$t1]["a"] < $gol[$t2]["a"]) $next[$label] = $t2;

			elseif($gol[$t1]["a"] == $gol[$t2]["a"]) $next[$label] = -1;
		}

		$rows[$label][] =($next[$label] >= 0) ? array("data" => $teams[$next[$label]]["name"], "style" => "font-weight:bold;") : array("data" => "Tempi Supplementari", "style" => "color: red;");
	}

	foreach($next as $label => $t_id){
		if($t_id >= 0){
			$sql = "UPDATE {league_matches} SET t1_id = '$t_id' WHERE t1_label = '$label'";
			$result = db_query($sql);
			$sql = "UPDATE {league_matches} SET t2_id = '$t_id' WHERE t2_label = '$label'";
			$result = db_query($sql);
		}
	}

	return theme_table($header, $rows);
}

function get_matches_vote_round($vote_round){

	$matches = array();

	$sql = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d'";
	$result = db_query($sql, $vote_round);
	while($row = db_fetch_array($result)){
		$l_id = $row['l_id'];
		$league_round = $row['league_round'];

		$matches_leagues = get_round_matches($league_round, '', $l_id);
		$matches = array_merge($matches, $matches_leagues);

	}

	return $matches;
}

function get_matches_next($vote_round){

	$matches = get_matches_vote_round($vote_round);

	$matches_next = array();
	$match_labels = array();
	foreach($matches as $m_id => $match){
		if($match->next == 1) {
			$match_labels[] = "'".$match->match_label."'";
		}
	}

	if($match_labels){
		$sql = "SELECT * FROM {league_matches} WHERE match_label IN (".implode(",", $match_labels).")";
		$result = db_query($sql);
		while($row = db_fetch_object($result)){
			$matches_next[$row->match_label][$row->m_id] = $row;
		}
	}
	return $matches_next;
}