<?php

#Funzioni per la visualizzazione dei blocchi del modulo fantacalcio

function fantacalcio_block_riepilogo(){

	$out = ''; $out_li = '';

	$out_li .= fantacalcio_avviso_formazioni();
	$out_li .= fantacalcio_avviso_sondaggi();
	$out_li .= fantacalcio_avviso_forum();
	$out_li .= fantacalcio_avviso_scommesse();

	if(!empty($out_li))
		$out .= "\n<div>
				<ul>"
			.$out_li
			."\n</ul>
				</div>";

	return $out;
}

function fantacalcio_avviso_formazioni(){

	$check = check_formazione_inserita();
	if($check['errors'] != 0){

		$text = "Inserire la formazione entro ".date_transform($check['date']);
		$out = l($text, 'insformazione');
	}
	else $out = '';

	if (empty($out)) return;
	return "\n<li>".$out."</li>";
}

function fantacalcio_avviso_sondaggi(){

	$non_voted_polls = get_non_voted_polls();
	#$non_voted_polls = array(array('id'=> 1), array('id' => 2));

	if(count($non_voted_polls) > 0) {
		$sondaggi = count($non_voted_polls) == 1 ? 'sondaggio non votato' : 'sondaggi non votati';
		$out = l(count($non_voted_polls).' '.$sondaggi, 'node/'.$non_voted_polls[0]);
	}
	else $out = '';

	if (empty($out)) return;
	return "\n<li>".$out."</li>";
}

function fantacalcio_avviso_forum(){

	global $user;

	$date_last_round = get_ts_last_round();

	$ts_last_round = mktime(substr($date_last_round, 11, 2), substr($date_last_round, 14, 2), substr($date_last_round, 17, 2),
				substr($date_last_round, 5, 2), substr($date_last_round, 8, 2), substr($date_last_round, 0, 4));

	$sql = "SELECT nid FROM {node} " .
			"WHERE type = 'forum' " .
			"AND uid = '%d' " .
			"AND created > '%d' " .
			"UNION " .
			"SELECT cid FROM {comments} " .
			"WHERE uid = '%d' " .
			"AND timestamp > '%d' " ;
	$result = db_query($sql, $user->uid, $ts_last_round, $user->uid, $ts_last_round);
	if(db_affected_rows($result) == 0)
		return "<li>".l('Non hai lasciato un messaggio sul forum', 'forum')."</li>";

	return;

}

function get_non_voted_polls(){

	global $user;

	if($user->uid > 0){

		#active polls
		$active_polls = array();
		$sql = "SELECT nid FROM {poll} WHERE active = 1";
		$result = db_query($sql);
		while($row = db_fetch_array($result)){
			array_push($active_polls, $row['nid']);
		}

		#active decisions without electoral list
		$sql = "SELECT nid FROM {decisions} WHERE active = 1 AND uselist = 0";
		$result = db_query($sql);
		while($row = db_fetch_array($result)){
			array_push($active_polls, $row['nid']);
		}

		#active decisions with electoral list
		$sql = "SELECT nid FROM {decisions_electoral_list} WHERE uid = '%d' AND nid IN (SELECT nid FROM {decisions} WHERE active = 1 AND uselist = 1)";
		$result = db_query($sql, $user->uid);
		while($row = db_fetch_array($result)){
			array_push($active_polls, $row['nid']);
		}

		#voted_polls
		$voted_polls = array();
		$sql = "SELECT * FROM {poll_votes} WHERE uid = '%d'";
		$result = db_query($sql, $user->uid);
		while($row = db_fetch_array($result)){
			$voted_polls[] = $row['nid'];
		}

		#voted decisions
		$sql = "SELECT DISTINCT content_id FROM {votingapi_vote} WHERE uid = '%d'";
		$result = db_query($sql, $user->uid);
		while($row = db_fetch_array($result)){
			$voted_polls[] = $row['content_id'];
		}

		$non_voted_polls = array();
		foreach($active_polls as $poll_id => $poll){
			if(!in_array($poll, $voted_polls))
				$non_voted_polls[] = $poll;
		}

		return $non_voted_polls;

	}
	else return array();
}

function get_ts_last_round(){

	$sql = "SELECT MAX(date) FROM {league_matches} WHERE date < '".date('Y-m-d H:i:s')."'";
	$date = date('Y-m-d H:i:s', time());
	$result = db_query($sql);
	return db_result($result);

}

function check_formazione_inserita(){

	global $user;

	$last_round = get_last_votes();
	$t_id = get_team_id($user->uid);

	$rounds = array();
	$sql = "SELECT * FROM {fanta_votes_round} WHERE vote_round = '%d'";
	$result = db_query($sql, $last_round +1);
	while($row = db_fetch_array($result)){
		$rounds[$row['l_id']] = $row['league_round'];
	}

	$errors = 0;
	$date = "0000-00-00 00:00:00";
	foreach($rounds as $l_id => $round){

		$sql = "SELECT * FROM {league_matches} " .
				"WHERE l_id ='%d' " .
				"AND round = '%d' " .
				"AND (t1_id = '%d' OR t2_id = '%d')";
		$result = db_query($sql, $l_id, $round, $t_id, $t_id);
		while($row = db_fetch_array($result)){
			$date = get_timestamp($row['date']);
			if( ($date - time() ) < 86400 && ($date - time() ) > 0 ){
				$sqla = "SELECT * FROM {fanta_formazioni_insert} " .
						"WHERE t_id = '%d' " .
						"AND l_id = '%d' " .
						"AND round = '%d'";
				$resulta = db_query($sqla, $t_id, $l_id, $round);

				if(db_affected_rows($resulta) == 0) $errors++;
			}

		}

	}

	return array("errors" => $errors, "date" => $date);

}

function get_timestamp($date){

	$y = substr($date, 0, 4);
	$m = substr($date, 5, 2);
	$d = substr($date, 8, 2);
	$h = substr($date, 11, 2);
	$i = substr($date, 14, 2);
	$s = substr($date, 17, 2);

	return mktime($h, $i, $s, $m, $d, $y);

}

function date_transform($ts){
	setlocale(LC_TIME,"it_IT");
	if(date('Y-m-d', $ts) == date('Y-m-d')) return " le ".date("H:i", $ts);
	else {
		$d = array("lun" => "lunedì", "mar" => "martedì", "mer" => "mercoledì", "gio" => "giovedì", "ven" => "venerdì", "sab" => "sabato" ,"dom" => "domenica" );
		$day = $d[strftime('%a', $ts)];
		return $day.strftime(' %e %B', $ts)." ore ".date("H:i", $ts);
	}
}

function fantacalcio_avviso_scommesse(){

	global $user;

	$round = get_next_round(1);

	$sql = "SELECT date FROM {league_matches} " .
			"WHERE l_id = 1 AND round = '%d'";
	$result = db_query($sql, $round);
	$ts_match = get_timestamp(db_result($result));

	if(time() > ($ts_match - 86400) && time() < $ts_match){

		$round = get_next_round(1);
		$sql = "SELECT * FROM {bets} " .
				"WHERE round = '%d' " .
				"AND u_id = '%d'";
		$result = db_query($sql, $round, $user->uid);
		if(db_affected_rows($result) == 0){
			return "<li>".l('Sicuro di non voler scommettere ;) ?!?!', 'scommesse/gioca')."</li>";
		}
		else return "";
	}
	else return "";

}