<?php

function fantacalcio_homepage(){

	#Css files
	drupal_add_css("sites/all/modules/fantacalcio/css/home.css", "themes", "all", FALSE);
	drupal_add_css("sites/all/plugins/tabSwitch/tabSwitch.css", "themes", "all", FALSE);

	#JS files
	drupal_add_js("sites/all/modules/fantacalcio/js/home.js");
	drupal_add_js("sites/all/plugins/jquerycurvycorners/jquerycurvycorners/jquery.curvycorners.min.js");
	drupal_add_js("sites/all/plugins/tabSwitch/jquery.tabswitch.yui.js");
	drupal_add_js("sites/all/plugins/tabSwitch/tabSwitch.title.js");

	$out = "<div>
				<div id='home_left'>
					<div id='last-blog'>".home_last_blog_post(4)."</div>
					<div id='last-forum' class='c'>".home_last_forum_content()."\n</div>
					<div id='last-news' class='c'>".home_last_rss_news(5)."\n</div>
				</div>
				<div id='home_right'>
					<div id='last-round'>".make_tabs('home_situation', 'campionato')."</div>
				</div>
			</div>";

	return $out;

}

function home_last_blog_post($n = 5){

	$users = get_users(); $posts = array(); $i = 1;

	$sql = "SELECT * FROM {node} n, {node_revisions} r " .
			"WHERE n.nid = r.nid " .
			"AND (n.type = 'blog' OR n.type = 'audio' OR n.type = 'video') " .
			"ORDER BY n.created DESC " .
			"LIMIT 0, $n";
	$result = db_query($sql);
	while($row = db_fetch_array($result)){
		$title = truncate(strtolower($row['title']), 40);
		$teaser = truncate($row['teaser'], 150);
		$link = "node/".$row['nid'];
		$author = $users[$row['uid']]->name;

		$comments = get_node_comments($row['nid']);
		$vote = get_node_votes($row['nid']);

		$posts[$i] = "\n<li>"
				."<h4><a href='".$link."'>".$title."</a></h4>"
				."<p class='info'>"
				.strip_tags($teaser)
				."</p>"
				."<p class='info'><span>di ".$author."</span>"
				."<span class='comments'> (".$comments.")</span></p>"
				."<p class='vote'>$vote</p>"
				."</li>";
		$i++;
	}

	$out = "<div id='HeadTitle'>
				<div id='MainTWI'>
					<div id='TWI1' class='TWITab'>".$posts[1]."</div>
					<div id='TWI2' class='TWITab'>".$posts[2]."</div>
					<div id='TWI3' class='TWITab'>".$posts[3]."</div>
					<div id='TWI4' class='TWITab'>".$posts[4]."</div>
				</div>
				<div id='ColorSelector'>
					<div id='TWICS1' class='TWICS'>1</div>
					<div id='TWICS2' class='TWICS'>2</div>
					<div id='TWICS3' class='TWICS'>3</div>
					<div id='TWICS4' class='TWICS'>4</div>
				</div>
			</div>";

	return $out;

}

function home_last_forum_content(){

	$out = "<h3>Ultime dal forum</h3>";

	$users = get_users();

	$out .= "<ul>";

	$sql = db_rewrite_sql("SELECT n.nid, n.title, n.uid, l.comment_count FROM {node} n INNER JOIN {term_node} tn ON tn.vid = n.vid INNER JOIN {term_data} td ON td.tid = tn.tid INNER JOIN {node_comment_statistics} l ON n.nid = l.nid WHERE n.status = 1 AND td.vid = %d ORDER BY n.nid DESC");
    $result = db_query_range($sql, variable_get('forum_nav_vocabulary', ''), 0, variable_get('forum_block_num_1', '5'));
    while($row = db_fetch_array($result)){
    	$title = $row['title'];
		$link = "node/".$row['nid'];
		$author = $users[$row['uid']]->name;
		$out .= "\n<li>"
				."<a href='".$link."'>".$title."</a>"
				." di ".$author
				."</li>";
    }
	$out .= "\n</ul>";

	return $out;
}

function home_last_rss_news($n = 5){

	include('sites/all/plugins/magpierss/rss_fetch.inc');

	$out = "<h3>Ultime News da Gazzetta.it</h3>" .
			"\n<ul>";

	$rss = fetch_rss("http://www.gazzetta.it/rss/Calcio.xml");

	$i = 0;

	if($rss){
		foreach ($rss->items as $item) {
			if($i < $n){
			    if(!empty($item['description'])) {
			        $out .= "\n<li><a href='".$item["link"]."'>"
			        		.htmlentities(strip_tags($item["title"]))
			        		."</a></li>";
				}
			}
			$i++;
		}
	}

	$out .= "</ul>";

	return $out;

}

function home_situation($g_id){

	$js = "$(function(){
			$('#groups').tabs({fxFade:true});
			});
			";
	//drupal_add_js($js, 'inline');

	$round = get_last_round($g_id);
	if($round > 0)
		$out = "<h3>".$round."&ordf; giornata</h3><br>";

	$out .= home_last_matches($g_id, $round);
	$out .= home_standings($g_id);
	$out .= home_next_matches($g_id, $round);

	return $out;
}

function home_last_matches($g_id, $round){

	if($round == 0) return '';

	$stampa = "<table style=\"font-size: 90%;\"><tr><th colspan=\"6\">Risultati</th></tr>";

	$i = 0;
	$teams = get_teams();
	$sql = "SELECT t1_id, t2_id, gol_1, gol_2
			FROM {league_matches}
			WHERE round = '%d'
			AND g_id = '%d'";
	$result = db_query($sql, $round, $g_id);
	while($row = db_fetch_array($result)){
		$i++;

		$j = $i%2 +1;

		$class = "role_".$j;

		$stampa .= "\n<tr class='$class'>"
				."\n<td style='width: 40%;'>".$teams[$row['t1_id']]['name']."</td>"
				."\n<td style='width: 40%;'>".$teams[$row['t2_id']]['name']."</td>"
				."\n<td style='width: 10%;'>".$row['gol_1']."</td>"
				."\n<td style='width: 10%;'>".$row['gol_2']."</td>"
				."\n</tr>";
	}

	$stampa .= "</table>";

	return $stampa;

}

function home_next_matches($g_id, $round){
	$i = 0;
	$teams = get_teams();

	$round = $round +1;

	$stampa = "<table style=\"font-size: 90%;\"><tr><th colspan=\"3\">Prossimo Turno</th></tr>";

	$sql = "SELECT t1_id, t2_id
			FROM {league_matches}
			WHERE round = '%d'
			AND g_id = '%d'";
	$result = db_query($sql, $round, $g_id);
	while($row = mysql_fetch_array($result)){
		$i++;

		$j = $i%2 +1;

		$classe = "role_".$j;

		$stampa .= "<tr>"
			."\n<td style=\"width: 50%;\" class=\"$classe\">".$teams[$row['t1_id']]['name']."</td>"
			."\n<td style=\"width: 50%;\" class=\"$classe\">".$teams[$row['t2_id']]['name']."</td>"
			."\n</tr>";
	}

	$stampa .= "</table>";

	return $stampa;

}

function home_standings($g_id){

	$teams = get_teams(); $points = array();

	$teams = filter_team_group($teams, $g_id);

	foreach($teams as $team){
		$t_id = $team['t_id'];
		$points[$t_id] = 0;
		$sql = "SELECT *
				FROM {league_matches}
				WHERE (t1_id = $t_id OR t2_id = $t_id)
				AND g_id = $g_id
				AND played = 1 ";
		$result = db_query($sql);
		while($row = db_fetch_array($result)){
			if($row['winner_id'] == $t_id)
				$points[$t_id] += 3;
			elseif($row['winner_id'] == -1)
				$points[$t_id] += 1;
		}
	}

	array_multisort($points, SORT_DESC, $teams);

	$i = 0; $standings = array();
	foreach($points as $t_id => $point){
		$standings[$i]['t_id'] = $t_id;
		$standings[$i]['point'] = $point;
		$i++;
	}

	$out = "<table style=\"font-size: 90%;\"><tr><th colspan=\"4\">Classifica</th></tr>";

	foreach($standings as $i => $standing){
		if($i < 4){
			$j = $i%2 +1;

			$t2_id = $standings[$i + 4]['t_id'];

			$class = "role_".$j;

			$out .= "<tr>"
				."\n<td style=\"width: 40%;\" class=\"$class\">".$teams[$standing['t_id']]['name']."</td>"
				."\n<td style=\"width: 10%;\" class=\"$class\" align=\"right\">".$standing['point']."</td>"
				."\n<td style=\"width: 40%;\" class=\"$class\">".$teams[$t2_id]['name']."</td>"
				."\n<td style=\"width: 10%;\" class=\"$class\" align=\"right\">".$standings[$t2_id]['point']."</td>"
				."\n</tr>";
		}
	}

	$out .= "</table>";

	return $out;

}

function get_node_comments($nid){

	$sql = "SELECT COUNT(*) FROM {comments} " .
			"WHERE nid = '%d' " .
			"AND status = 0";
	$result = db_query($sql, $nid);
	$comments = db_result($result);
	return ($comments == 1) ? "1 commento" : $comments." commenti";
}

function get_node_votes($nid){

	$votes = 0; $percent = 0;
	$sql = "SELECT * FROM {votingapi_vote} " .
			"WHERE content_id = '%d' ";
	$result = db_query($sql, $nid);
	while($row = db_fetch_array($result)){
		$percent += $row['value'];
		$votes++;
	}

	$out = "";
	for($i = 1; $i <= 5; $i++){
		$class = ($i <= ($percent / 20)) ? "voted" : "non_voted" ;
		$out .= "<span class='$class'></span>";
	}

	return $out;

}
